Overview | Package | Class | Tree | Deprecated | Index | Help
| SNMP Stack 5_1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## uk.co.westhawk.examplev1
Class InetCidrRouteTablePdu

    java.lang.Object
      |
      +--java.util.Observable
            |
            +--uk.co.westhawk.snmp.stack.Pdu
                  |
                  +--uk.co.westhawk.snmp.stack.GetNextPdu
                        |
                        +--uk.co.westhawk.examplev1.InetCidrRouteTablePdu

public class InetCidrRouteTablePdu
extends GetNextPdu

The class InetCidrRouteTablePdu. This file is auto generated by the StubBrowser utility, using Mibble. See the uk/co/westhawk/stub/ directory. Make sure that you replace the package name and classname placeholders. Also, move this file to the correct package directory. If these things are not done, this class will not compile correctly!!

Version:
  $Revision: 1.2 $ $Date: 2006/03/23 14:40:58 $

Field Summary
`protected java.lang.Long` | `_inetCidrRouteAge`
`protected java.lang.Integer` | `_inetCidrRouteIfIndex`
`protected java.lang.Integer` | `_inetCidrRouteMetric1`
`protected java.lang.Integer` | `_inetCidrRouteMetric2`
`protected java.lang.Integer` | `_inetCidrRouteMetric3`
`protected java.lang.Integer` | `_inetCidrRouteMetric4`
`protected java.lang.Integer` | `_inetCidrRouteMetric5`
`protected java.lang.Long` | `_inetCidrRouteNextHopAS`
`protected java.lang.Integer` | `_inetCidrRouteProto`
`protected java.util.HashMap` | `_inetCidrRouteProtoMap`
`protected java.lang.Integer` | `_inetCidrRouteStatus`
`protected java.util.HashMap` | `_inetCidrRouteStatusMap`
`protected java.lang.Integer` | `_inetCidrRouteType`
`protected java.util.HashMap` | `_inetCidrRouteTypeMap`
`protected boolean` | `_invalid`
`protected int` | `_tmpErrorInd`
`protected int` | `_tmpErrorStat`
`static java.lang.String[]` | `all_oids`
`static java.lang.String[]` | `col_oids`
`static java.lang.String` | `inetCidrRouteAge_OID`
`static java.lang.String` | `inetCidrRouteIfIndex_OID`
`static java.lang.String` | `inetCidrRouteMetric1_OID`
`static java.lang.String` | `inetCidrRouteMetric2_OID`
`static java.lang.String` | `inetCidrRouteMetric3_OID`
`static java.lang.String` | `inetCidrRouteMetric4_OID`
`static java.lang.String` | `inetCidrRouteMetric5_OID`
`static java.lang.String` | `inetCidrRouteNextHopAS_OID`
`static java.lang.String` | `inetCidrRouteProto_OID`
`static java.lang.String` | `inetCidrRouteStatus_OID`
`static java.lang.String` | `inetCidrRouteType_OID`
`static int` | `NO_COL`
`static int` | `NO_OID`
`static int` | `NO_SCAL`
`static java.lang.String[]` | `scal_oids`

Fields inherited from class uk.co.westhawk.snmp.stack.Pdu
`added, answered, context, encodedPacket, errind, errstat, msg_type, reqVarbinds, respVarbinds, snmpv3MsgId`

Constructor Summary
`InetCidrRouteTablePdu(SnmpContextBasisFace con)` Constructor.
`InetCidrRouteTablePdu(SnmpContextBasisFace con, java.util.Observer o)` Constructor that will send the first request immediately.

Method Summary
`void` | `addOids(InetCidrRouteTablePdu old)` The method addOids is the basis for the GetNext functionality.
`void` | `addOids(int index)` This method sets the column index.
`java.lang.Long` | `getInetCidrRouteAge()`
`java.lang.Integer` | `getInetCidrRouteIfIndex()`
`java.lang.Integer` | `getInetCidrRouteMetric1()`
`java.lang.Integer` | `getInetCidrRouteMetric2()`
`java.lang.Integer` | `getInetCidrRouteMetric3()`
`java.lang.Integer` | `getInetCidrRouteMetric4()`
`java.lang.Integer` | `getInetCidrRouteMetric5()`
`java.lang.Long` | `getInetCidrRouteNextHopAS()`
`java.lang.Integer` | `getInetCidrRouteProto()`
`java.lang.String` | `getInetCidrRouteProtoStr()`
`java.lang.Integer` | `getInetCidrRouteStatus()`
`java.lang.String` | `getInetCidrRouteStatusStr()`
`java.lang.Integer` | `getInetCidrRouteType()`
`java.lang.String` | `getInetCidrRouteTypeStr()`
`boolean` | `isInvalid()` Returns if this set of values is invalid.
`protected void` | `new_value(int n, varbind res)` The value of the request is set.
`void` | `setInetCidrRouteAge(AsnObject new_value)` inetCidrRouteAge TYPE Gauge32 ::= [APPLICATION 2] INTEGER (0..4294967295) OBJECT-TYPE ( Syntax: [APPLICATION 2] INTEGER (0..4294967295) Access: read-only Status: current Description: The number of seconds since this route was last updated or otherwise determined to be correct.
`void` | `setInetCidrRouteIfIndex(AsnObject new_value)` inetCidrRouteIfIndex TYPE InterfaceIndexOrZero ::= TEXTUAL-CONVENTION ( Display-Hint: d Status: current Description: This textual convention is an extension of the InterfaceIndex convention.
`void` | `setInetCidrRouteMetric1(AsnObject new_value)` inetCidrRouteMetric1 TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647) OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: The primary routing metric for this route.
`void` | `setInetCidrRouteMetric2(AsnObject new_value)` inetCidrRouteMetric2 TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647) OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route.
`void` | `setInetCidrRouteMetric3(AsnObject new_value)` inetCidrRouteMetric3 TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647) OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route.
`void` | `setInetCidrRouteMetric4(AsnObject new_value)` inetCidrRouteMetric4 TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647) OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route.
`void` | `setInetCidrRouteMetric5(AsnObject new_value)` inetCidrRouteMetric5 TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647) OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route.
`void` | `setInetCidrRouteNextHopAS(AsnObject new_value)` inetCidrRouteNextHopAS TYPE InetAutonomousSystemNumber ::= TEXTUAL-CONVENTION ( Display-Hint: d Status: current Description: Represents an autonomous system number that identifies an Autonomous System (AS).
`void` | `setInetCidrRouteProto(AsnObject new_value)` inetCidrRouteProto TYPE IANAipRouteProtocol ::= TEXTUAL-CONVENTION ( Status: current Description: A mechanism for learning routes.
`void` | `setInetCidrRouteStatus(AsnObject new_value)` inetCidrRouteStatus TYPE RowStatus ::= TEXTUAL-CONVENTION ( Status: current Description: The RowStatus textual convention is used to manage the creation and deletion of conceptual rows, and is used as the value of the SYNTAX clause for the status column of a conceptual row (as described in Section 7.7.1 of [2].)
`void` | `setInetCidrRouteType(AsnObject new_value)` inetCidrRouteType OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (1 | 2 | 3 | 4 | 5) Access: read-create Status: current Description: The type of route.
`java.lang.String` | `toString()` Returns the string representation of the PDU.

Methods inherited from class uk.co.westhawk.snmp.stack.Pdu
`addOid, addOid, addOid, addOid, addOid, addToTrans, getContext, getErrorIndex, getErrorStatus, getErrorStatusString, getMsgType, getReqId, getRequestVarbinds, getResponseVarbinds, isExpectingResponse, isTimedOut, notifyObservers, printVars, send, send, send, sendme, setErrorIndex, setErrorStatus, setErrorStatus, setMsgType, setRetryIntervals, tell_them, toString, waitForSelf`

Methods inherited from class java.util.Observable
`addObserver, clearChanged, countObservers, deleteObserver, deleteObservers, hasChanged, notifyObservers, setChanged`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### inetCidrRouteIfIndex_OID

    public static final java.lang.String inetCidrRouteIfIndex_OID

See Also:
  Constant Field Values

### inetCidrRouteType_OID

    public static final java.lang.String inetCidrRouteType_OID

See Also:
  Constant Field Values

### inetCidrRouteProto_OID

    public static final java.lang.String inetCidrRouteProto_OID

See Also:
  Constant Field Values

### inetCidrRouteAge_OID

    public static final java.lang.String inetCidrRouteAge_OID

See Also:
  Constant Field Values

### inetCidrRouteNextHopAS_OID

    public static final java.lang.String inetCidrRouteNextHopAS_OID

See Also:
  Constant Field Values

### inetCidrRouteMetric1_OID

    public static final java.lang.String inetCidrRouteMetric1_OID

See Also:
  Constant Field Values

### inetCidrRouteMetric2_OID

    public static final java.lang.String inetCidrRouteMetric2_OID

See Also:
  Constant Field Values

### inetCidrRouteMetric3_OID

    public static final java.lang.String inetCidrRouteMetric3_OID

See Also:
  Constant Field Values

### inetCidrRouteMetric4_OID

    public static final java.lang.String inetCidrRouteMetric4_OID

See Also:
  Constant Field Values

### inetCidrRouteMetric5_OID

    public static final java.lang.String inetCidrRouteMetric5_OID

See Also:
  Constant Field Values

### inetCidrRouteStatus_OID

    public static final java.lang.String inetCidrRouteStatus_OID

See Also:
  Constant Field Values

### NO_SCAL

    public static final int NO_SCAL

See Also:
  Constant Field Values

### NO_COL

    public static final int NO_COL

See Also:
  Constant Field Values

### NO_OID

    public static final int NO_OID

See Also:
  Constant Field Values

### scal_oids

    public static final java.lang.String[] scal_oids

### col_oids

    public static final java.lang.String[] col_oids

### all_oids

    public static final java.lang.String[] all_oids

### _inetCidrRouteIfIndex

    protected java.lang.Integer _inetCidrRouteIfIndex

### _inetCidrRouteTypeMap

    protected java.util.HashMap _inetCidrRouteTypeMap

### _inetCidrRouteType

    protected java.lang.Integer _inetCidrRouteType

### _inetCidrRouteProtoMap

    protected java.util.HashMap _inetCidrRouteProtoMap

### _inetCidrRouteProto

    protected java.lang.Integer _inetCidrRouteProto

### _inetCidrRouteAge

    protected java.lang.Long _inetCidrRouteAge

### _inetCidrRouteNextHopAS

    protected java.lang.Long _inetCidrRouteNextHopAS

### _inetCidrRouteMetric1

    protected java.lang.Integer _inetCidrRouteMetric1

### _inetCidrRouteMetric2

    protected java.lang.Integer _inetCidrRouteMetric2

### _inetCidrRouteMetric3

    protected java.lang.Integer _inetCidrRouteMetric3

### _inetCidrRouteMetric4

    protected java.lang.Integer _inetCidrRouteMetric4

### _inetCidrRouteMetric5

    protected java.lang.Integer _inetCidrRouteMetric5

### _inetCidrRouteStatusMap

    protected java.util.HashMap _inetCidrRouteStatusMap

### _inetCidrRouteStatus

    protected java.lang.Integer _inetCidrRouteStatus

### _invalid

    protected boolean _invalid

### _tmpErrorInd

    protected int _tmpErrorInd

### _tmpErrorStat

    protected int _tmpErrorStat

Constructor Detail

### InetCidrRouteTablePdu

    public InetCidrRouteTablePdu(SnmpContextBasisFace con)

  Constructor.

Parameters:
  `con` - The context of the request

### InetCidrRouteTablePdu

    public InetCidrRouteTablePdu(SnmpContextBasisFace con,
                                 java.util.Observer o)
                          throws PduException,
                                 java.io.IOException

  Constructor that will send the first request immediately.

Parameters:
  `con` - The context of the request
  `o` - the Observer that will be notified when the answer is received

Method Detail

### addOids

    public void addOids(InetCidrRouteTablePdu old)

  The method addOids is the basis for the GetNext functionality. If old is null, it initialises the varbinds from all_oids. If old is not null, it copies the column OIDs from the old InetCidrRouteTablePdu object. so the request continues where the previous one left. Note, the scalars and the columns OIDs are handled differently. The scalars are always copied from the original scal_oids, only the column OIDs are copied from the old InetCidrRouteTablePdu object.

### addOids

    public void addOids(int index)

  This method sets the column index. By doing this, the request will return (only) the row after row index. The index parameters only applies to the column OIDs. The scalars are copied from the original scal_oids.

### new_value

    protected void new_value(int n,
                             varbind res)

  The value of the request is set. This will be called by Pdu.fillin(). I check if the variables are still in range. I do this because I'm only interessed in a part of the MIB. If I would not do this check, I'll get the whole MIB from the starting point, instead of the variables in the table.

  Overrides:
    `new_value` in class `Pdu`
  Parameters:
    `n` - the index of the value
  See Also:
    `Pdu.new_value(int, uk.co.westhawk.snmp.stack.varbind)`

### setInetCidrRouteIfIndex

    public void setInetCidrRouteIfIndex(AsnObject new_value)

  inetCidrRouteIfIndex
  TYPE InterfaceIndexOrZero ::= TEXTUAL-CONVENTION ( Display-Hint: d Status: current Description: This textual convention is an extension of the InterfaceIndex convention. The latter defines a greater than zero value used to identify an interface or interface sub-layer in the managed system. This extension permits the additional value of zero. the value zero is object-specific and must therefore be defined as part of the description of any object which uses this syntax. Examples of the usage of zero might include situations where interface was unknown, or when none or all interfaces need to be referenced. Syntax: [UNIVERSAL 2] INTEGER (0..2147483647) )
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (0..2147483647) Access: read-create Status: current Description: The ifIndex value which identifies the local interface through which the next hop of this route should be reached. A value of 0 is valid and represents the scenario where no interface is specified. )

### getInetCidrRouteIfIndex

    public java.lang.Integer getInetCidrRouteIfIndex()

### setInetCidrRouteType

    public void setInetCidrRouteType(AsnObject new_value)

  inetCidrRouteType
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (1 | 2 | 3 | 4 | 5) Access: read-create Status: current Description: The type of route. Note that local(3) refers to a route for which the next hop is the final destination; remote(4)refers to a route for which the next hop is not the final destination. Routes which do not result in traffic forwarding or rejection should not be displayed even if the implementation keeps them stored internally. reject(2) refers to a route which, if matched, discards the message as unreachable and returns a notification (e.g. ICMP error) to the message sender. This is used in some protocols as a means of correctly aggregating routes. blackhole(5) refers to a route which, if matched, discards the message silently. )

### getInetCidrRouteTypeStr

    public java.lang.String getInetCidrRouteTypeStr()

### getInetCidrRouteType

    public java.lang.Integer getInetCidrRouteType()

### setInetCidrRouteProto

    public void setInetCidrRouteProto(AsnObject new_value)

  inetCidrRouteProto
  TYPE IANAipRouteProtocol ::= TEXTUAL-CONVENTION ( Status: current Description: A mechanism for learning routes. Inclusion of values for routing protocols is not intended to imply that those protocols need be supported. Syntax: [UNIVERSAL 2] INTEGER (1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17) )
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17) Access: read-only Status: current Description: The routing mechanism via which this route was learned. Inclusion of values for gateway routing protocols is not intended to imply that hosts should support those protocols. )

### getInetCidrRouteProtoStr

    public java.lang.String getInetCidrRouteProtoStr()

### getInetCidrRouteProto

    public java.lang.Integer getInetCidrRouteProto()

### setInetCidrRouteAge

    public void setInetCidrRouteAge(AsnObject new_value)

  inetCidrRouteAge
  TYPE Gauge32 ::= [APPLICATION 2] INTEGER (0..4294967295)
  OBJECT-TYPE ( Syntax: [APPLICATION 2] INTEGER (0..4294967295) Access: read-only Status: current Description: The number of seconds since this route was last updated or otherwise determined to be correct. Note that no semantics of 'too old' can be implied except through knowledge of the routing protocol by which the route was learned. )

### getInetCidrRouteAge

    public java.lang.Long getInetCidrRouteAge()

### setInetCidrRouteNextHopAS

    public void setInetCidrRouteNextHopAS(AsnObject new_value)

  inetCidrRouteNextHopAS
  TYPE InetAutonomousSystemNumber ::= TEXTUAL-CONVENTION ( Display-Hint: d Status: current Description: Represents an autonomous system number that identifies an Autonomous System (AS). An AS is a set of routers under a single technical administration, using an interior gateway protocol and common metrics to route packets within the AS, and using an exterior gateway protocol to route packets to other ASes'. IANA maintains the AS number space and has delegated large parts to the regional registries. Autonomous system numbers are currently limited to 16 bits (0..65535). There is, however, work in progress to enlarge the autonomous system number space to 32 bits. Therefore, this textual convention uses an Unsigned32 value without a range restriction in order to support a larger autonomous system number space. Reference: RFC 1771, RFC 1930 Syntax: [APPLICATION 2] INTEGER (0..4294967295) )
  OBJECT-TYPE ( Syntax: [APPLICATION 2] INTEGER (0..4294967295) Access: read-create Status: current Description: The Autonomous System Number of the Next Hop. The semantics of this object are determined by the routing- protocol specified in the route's inetCidrRouteProto value. When this object is unknown or not relevant its value should be set to zero. Default Value: 0 )

### getInetCidrRouteNextHopAS

    public java.lang.Long getInetCidrRouteNextHopAS()

### setInetCidrRouteMetric1

    public void setInetCidrRouteMetric1(AsnObject new_value)

  inetCidrRouteMetric1
  TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647)
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: The primary routing metric for this route. The semantics of this metric are determined by the routing- protocol specified in the route's inetCidrRouteProto value. If this metric is not used, its value should be set to -1. Default Value: -1 )

### getInetCidrRouteMetric1

    public java.lang.Integer getInetCidrRouteMetric1()

### setInetCidrRouteMetric2

    public void setInetCidrRouteMetric2(AsnObject new_value)

  inetCidrRouteMetric2
  TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647)
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route. The semantics of this metric are determined by the routing- protocol specified in the route's inetCidrRouteProto value. If this metric is not used, its value should be set to -1. Default Value: -1 )

### getInetCidrRouteMetric2

    public java.lang.Integer getInetCidrRouteMetric2()

### setInetCidrRouteMetric3

    public void setInetCidrRouteMetric3(AsnObject new_value)

  inetCidrRouteMetric3
  TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647)
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route. The semantics of this metric are determined by the routing- protocol specified in the route's inetCidrRouteProto value. If this metric is not used, its value should be set to -1. Default Value: -1 )

### getInetCidrRouteMetric3

    public java.lang.Integer getInetCidrRouteMetric3()

### setInetCidrRouteMetric4

    public void setInetCidrRouteMetric4(AsnObject new_value)

  inetCidrRouteMetric4
  TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647)
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route. The semantics of this metric are determined by the routing- protocol specified in the route's inetCidrRouteProto value. If this metric is not used, its value should be set to -1. Default Value: -1 )

### getInetCidrRouteMetric4

    public java.lang.Integer getInetCidrRouteMetric4()

### setInetCidrRouteMetric5

    public void setInetCidrRouteMetric5(AsnObject new_value)

  inetCidrRouteMetric5
  TYPE Integer32 ::= [UNIVERSAL 2] INTEGER (-2147483648..2147483647)
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (-2147483648..2147483647) Access: read-create Status: current Description: An alternate routing metric for this route. The semantics of this metric are determined by the routing- protocol specified in the route's inetCidrRouteProto value. If this metric is not used, its value should be set to -1. Default Value: -1 )

### getInetCidrRouteMetric5

    public java.lang.Integer getInetCidrRouteMetric5()

### setInetCidrRouteStatus

    public void setInetCidrRouteStatus(AsnObject new_value)

  inetCidrRouteStatus
  TYPE RowStatus ::= TEXTUAL-CONVENTION ( Status: current Description: The RowStatus textual convention is used to manage the creation and deletion of conceptual rows, and is used as the value of the SYNTAX clause for the status column of a conceptual row (as described in Section 7.7.1 of [2].) The status column has six defined values: - `active', which indicates that the conceptual row is available for use by the managed device; - `notInService', which indicates that the conceptual row exists in the agent, but is unavailable for use by the managed device (see NOTE below); 'notInService' has no implication regarding the internal consistency of the row, availability of resources, or consistency with the current state of the managed device; - `notReady', which indicates that the conceptual row exists in the agent, but is missing information necessary in order to be available for use by the managed device (i.e., one or more required columns in the conceptual row have not been instanciated); - `createAndGo', which is supplied by a management station wishing to create a new instance of a conceptual row and to have its status automatically set to active, making it available for use by the managed device; - `createAndWait', which is supplied by a management station wishing to create a new instance of a conceptual row (but not make it available for use by the managed device); and, - `destroy', which is supplied by a management station wishing to delete all of the instances associated with an existing conceptual row. Whereas five of the six values (all except `notReady') may be specified in a management protocol set operation, only three values will be returned in response to a management protocol retrieval operation: `notReady', `notInService' or `active'. That is, when queried, an existing conceptual row has only three states: it is either available for use by the managed device (the status column has value `active'); it is not available for use by the managed device, though the agent has sufficient information to attempt to make it so (the status column has value `notInService'); or, it is not available for use by the managed device, and an attempt to make it so would fail because the agent has insufficient information (the state column has value `notReady'). NOTE WELL This textual convention may be used for a MIB table, irrespective of whether the values of that table's conceptual rows are able to be modified while it is active, or whether its conceptual rows must be taken out of service in order to be modified. That is, it is the responsibility of the DESCRIPTION clause of the status column to specify whether the status column must not be `active' in order for the value of some other column of the same conceptual row to be modified. If such a specification is made, affected columns may be changed by an SNMP set PDU if the RowStatus would not be equal to `active' either immediately before or after processing the PDU. In other words, if the PDU also contained a varbind that would change the RowStatus value, the column in question may be changed if the RowStatus was not equal to `active' as the PDU was received, or if the varbind sets the status to a value other than 'active'. Also note that whenever any elements of a row exist, the RowStatus column must also exist. To summarize the effect of having a conceptual row with a status column having a SYNTAX clause value of RowStatus, consider the following state diagram: STATE +--------------+-----------+-------------+------------- | A | B | C | D | |status col.|status column| |status column | is | is |status column ACTION |does not exist| notReady | notInService| is active --------------+--------------+-----------+-------------+------------- set status |noError ->D|inconsist- |inconsistent-|inconsistent- column to | or | entValue| Value| Value createAndGo |inconsistent- | | | | Value| | | --------------+--------------+-----------+-------------+------------- set status |noError see 1|inconsist- |inconsistent-|inconsistent- column to | or | entValue| Value| Value createAndWait |wrongValue | | | --------------+--------------+-----------+-------------+------------- set status |inconsistent- |inconsist- |noError |noError column to | Value| entValue| | active | | | | | | or | | | | | | | |see 2 ->D|see 8 ->D| ->D --------------+--------------+-----------+-------------+------------- set status |inconsistent- |inconsist- |noError |noError ->C column to | Value| entValue| | notInService | | | | | | or | | or | | | | | |see 3 ->C| ->C|see 6 --------------+--------------+-----------+-------------+------------- set status |noError |noError |noError |noError ->A column to | | | | or destroy | ->A| ->A| ->A|see 7 --------------+--------------+-----------+-------------+------------- set any other |see 4 |noError |noError |see 5 column to some| | | | value | | see 1| ->C| ->D --------------+--------------+-----------+-------------+------------- (1) goto B or C, depending on information available to the agent. (2) if other variable bindings included in the same PDU, provide values for all columns which are missing but required, and all columns have acceptable values, then return noError and goto D. (3) if other variable bindings included in the same PDU, provide legal values for all columns which are missing but required, then return noError and goto C. (4) at the discretion of the agent, the return value may be either: inconsistentName: because the agent does not choose to create such an instance when the corresponding RowStatus instance does not exist, or inconsistentValue: if the supplied value is inconsistent with the state of some other MIB object's value, or noError: because the agent chooses to create the instance. If noError is returned, then the instance of the status column must also be created, and the new state is B or C, depending on the information available to the agent. If inconsistentName or inconsistentValue is returned, the row remains in state A. (5) depending on the MIB definition for the column/table, either noError or inconsistentValue may be returned. (6) the return value can indicate one of the following errors: wrongValue: because the agent does not support notInService (e.g., an agent which does not support createAndWait), or inconsistentValue: because the agent is unable to take the row out of service at this time, perhaps because it is in use and cannot be de-activated. (7) the return value can indicate the following error: inconsistentValue: because the agent is unable to remove the row at this time, perhaps because it is in use and cannot be de-activated. (8) the transition to D can fail, e.g., if the values of the conceptual row are inconsistent, then the error code would be inconsistentValue. NOTE: Other processing of (this and other varbinds of) the set request may result in a response other than noError being returned, e.g., wrongValue, noCreation, etc. Conceptual Row Creation There are four potential interactions when creating a conceptual row: selecting an instance-identifier which is not in use; creating the conceptual row; initializing any objects for which the agent does not supply a default; and, making the conceptual row available for use by the managed device. Interaction 1: Selecting an Instance-Identifier The algorithm used to select an instance-identifier varies for each conceptual row. In some cases, the instance- identifier is semantically significant, e.g., the destination address of a route, and a management station selects the instance-identifier according to the semantics. In other cases, the instance-identifier is used solely to distinguish conceptual rows, and a management station without specific knowledge of the conceptual row might examine the instances present in order to determine an unused instance-identifier. (This approach may be used, but it is often highly sub-optimal; however, it is also a questionable practice for a naive management station to attempt conceptual row creation.) Alternately, the MIB module which defines the conceptual row might provide one or more objects which provide assistance in determining an unused instance-identifier. For example, if the conceptual row is indexed by an integer-value, then an object having an integer-valued SYNTAX clause might be defined for such a purpose, allowing a management station to issue a management protocol retrieval operation. In order to avoid unnecessary collisions between competing management stations, `adjacent' retrievals of this object should be different. Finally, the management station could select a pseudo-random number to use as the index. In the event that this index was already in use and an inconsistentValue was returned in response to the management protocol set operation, the management station should simply select a new pseudo-random number and retry the operation. A MIB designer should choose between the two latter algorithms based on the size of the table (and therefore the efficiency of each algorithm). For tables in which a large number of entries are expected, it is recommended that a MIB object be defined that returns an acceptable index for creation. For tables with small numbers of entries, it is recommended that the latter pseudo-random index mechanism be used. Interaction 2: Creating the Conceptual Row Once an unused instance-identifier has been selected, the management station determines if it wishes to create and activate the conceptual row in one transaction or in a negotiated set of interactions. Interaction 2a: Creating and Activating the Conceptual Row The management station must first determine the column requirements, i.e., it must determine those columns for which it must or must not provide values. Depending on the complexity of the table and the management station's knowledge of the agent's capabilities, this determination can be made locally by the management station. Alternately, the management station issues a management protocol get operation to examine all columns in the conceptual row that it wishes to create. In response, for each column, there are three possible outcomes: - a value is returned, indicating that some other management station has already created this conceptual row. We return to interaction 1. - the exception `noSuchInstance' is returned, indicating that the agent implements the object-type associated with this column, and that this column in at least one conceptual row would be accessible in the MIB view used by the retrieval were it to exist. For those columns to which the agent provides read-create access, the `noSuchInstance' exception tells the management station that it should supply a value for this column when the conceptual row is to be created. - the exception `noSuchObject' is returned, indicating that the agent does not implement the object-type associated with this column or that there is no conceptual row for which this column would be accessible in the MIB view used by the retrieval. As such, the management station can not issue any management protocol set operations to create an instance of this column. Once the column requirements have been determined, a management protocol set operation is accordingly issued. This operation also sets the new instance of the status column to `createAndGo'. When the agent processes the set operation, it verifies that it has sufficient information to make the conceptual row available for use by the managed device. The information available to the agent is provided by two sources: the management protocol set operation which creates the conceptual row, and, implementation-specific defaults supplied by the agent (note that an agent must provide implementation-specific defaults for at least those objects which it implements as read-only). If there is sufficient information available, then the conceptual row is created, a `noError' response is returned, the status column is set to `active', and no further interactions are necessary (i.e., interactions 3 and 4 are skipped). If there is insufficient information, then the conceptual row is not created, and the set operation fails with an error of `inconsistentValue'. On this error, the management station can issue a management protocol retrieval operation to determine if this was because it failed to specify a value for a required column, or, because the selected instance of the status column already existed. In the latter case, we return to interaction 1. In the former case, the management station can re-issue the set operation with the additional information, or begin interaction 2 again using `createAndWait' in order to negotiate creation of the conceptual row. NOTE WELL Regardless of the method used to determine the column requirements, it is possible that the management station might deem a column necessary when, in fact, the agent will not allow that particular columnar instance to be created or written. In this case, the management protocol set operation will fail with an error such as `noCreation' or `notWritable'. In this case, the management station decides whether it needs to be able to set a value for that particular columnar instance. If not, the management station re-issues the management protocol set operation, but without setting a value for that particular columnar instance; otherwise, the management station aborts the row creation algorithm. Interaction 2b: Negotiating the Creation of the Conceptual Row The management station issues a management protocol set operation which sets the desired instance of the status column to `createAndWait'. If the agent is unwilling to process a request of this sort, the set operation fails with an error of `wrongValue'. (As a consequence, such an agent must be prepared to accept a single management protocol set operation, i.e., interaction 2a above, containing all of the columns indicated by its column requirements.) Otherwise, the conceptual row is created, a `noError' response is returned, and the status column is immediately set to either `notInService' or `notReady', depending on whether it has sufficient information to (attempt to) make the conceptual row available for use by the managed device. If there is sufficient information available, then the status column is set to `notInService'; otherwise, if there is insufficient information, then the status column is set to `notReady'. Regardless, we proceed to interaction 3. Interaction 3: Initializing non-defaulted Objects The management station must now determine the column requirements. It issues a management protocol get operation to examine all columns in the created conceptual row. In the response, for each column, there are three possible outcomes: - a value is returned, indicating that the agent implements the object-type associated with this column and had sufficient information to provide a value. For those columns to which the agent provides read-create access (and for which the agent allows their values to be changed after their creation), a value return tells the management station that it may issue additional management protocol set operations, if it desires, in order to change the value associated with this column. - the exception `noSuchInstance' is returned, indicating that the agent implements the object-type associated with this column, and that this column in at least one conceptual row would be accessible in the MIB view used by the retrieval were it to exist. However, the agent does not have sufficient information to provide a value, and until a value is provided, the conceptual row may not be made available for use by the managed device. For those columns to which the agent provides read-create access, the `noSuchInstance' exception tells the management station that it must issue additional management protocol set operations, in order to provide a value associated with this column. - the exception `noSuchObject' is returned, indicating that the agent does not implement the object-type associated with this column or that there is no conceptual row for which this column would be accessible in the MIB view used by the retrieval. As such, the management station can not issue any management protocol set operations to create an instance of this column. If the value associated with the status column is `notReady', then the management station must first deal with all `noSuchInstance' columns, if any. Having done so, the value of the status column becomes `notInService', and we proceed to interaction 4. Interaction 4: Making the Conceptual Row Available Once the management station is satisfied with the values associated with the columns of the conceptual row, it issues a management protocol set operation to set the status column to `active'. If the agent has sufficient information to make the conceptual row available for use by the managed device, the management protocol set operation succeeds (a `noError' response is returned). Otherwise, the management protocol set operation fails with an error of `inconsistentValue'. NOTE WELL A conceptual row having a status column with value `notInService' or `notReady' is unavailable to the managed device. As such, it is possible for the managed device to create its own instances during the time between the management protocol set operation which sets the status column to `createAndWait' and the management protocol set operation which sets the status column to `active'. In this case, when the management protocol set operation is issued to set the status column to `active', the values held in the agent supersede those used by the managed device. If the management station is prevented from setting the status column to `active' (e.g., due to management station or network failure) the conceptual row will be left in the `notInService' or `notReady' state, consuming resources indefinitely. The agent must detect conceptual rows that have been in either state for an abnormally long period of time and remove them. It is the responsibility of the DESCRIPTION clause of the status column to indicate what an abnormally long period of time would be. This period of time should be long enough to allow for human response time (including `think time') between the creation of the conceptual row and the setting of the status to `active'. In the absence of such information in the DESCRIPTION clause, it is suggested that this period be approximately 5 minutes in length. This removal action applies not only to newly-created rows, but also to previously active rows which are set to, and left in, the notInService state for a prolonged period exceeding that which is considered normal for such a conceptual row. Conceptual Row Suspension When a conceptual row is `active', the management station may issue a management protocol set operation which sets the instance of the status column to `notInService'. If the agent is unwilling to do so, the set operation fails with an error of `wrongValue' or `inconsistentValue'. Otherwise, the conceptual row is taken out of service, and a `noError' response is returned. It is the responsibility of the DESCRIPTION clause of the status column to indicate under what circumstances the status column should be taken out of service (e.g., in order for the value of some other column of the same conceptual row to be modified). Conceptual Row Deletion For deletion of conceptual rows, a management protocol set operation is issued which sets the instance of the status column to `destroy'. This request may be made regardless of the current value of the status column (e.g., it is possible to delete conceptual rows which are either `notReady', `notInService' or `active'.) If the operation succeeds, then all instances associated with the conceptual row are immediately removed. Syntax: [UNIVERSAL 2] INTEGER (1 | 2 | 3 | 4 | 5 | 6) )
  OBJECT-TYPE ( Syntax: [UNIVERSAL 2] INTEGER (1 | 2 | 3 | 4 | 5 | 6) Access: read-create Status: current Description: The row status variable, used according to row installation and removal conventions. A row entry cannot be modified when the status is marked as active(1). )

### getInetCidrRouteStatusStr

    public java.lang.String getInetCidrRouteStatusStr()

### getInetCidrRouteStatus

    public java.lang.Integer getInetCidrRouteStatus()

### isInvalid

    public boolean isInvalid()

  Returns if this set of values is invalid.

### toString

    public java.lang.String toString()

  Description copied from class: `Pdu`
  Returns the string representation of the PDU.

  Overrides:
    `toString` in class `Pdu`
  Returns:
    The string of the PDU

Overview | Package | Class | Tree | Deprecated | Index | Help
| SNMP Stack 5_1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD